scanread
% these scans were all taken with the x-z plane as the probing plane - so
% all plane fitting needs to be done within the x-z data ranges
% 
% Want to fit the plane Ax + By + Cz + D = 0 to the data
% solve for y (because of probing plane):
% y=(-A/B)x + (-C/B)z -D
% y = (-D) + (-A/B)x + (-C/B)z
% in the form
% y = a0 + a1 * x0 + a2 * x1


X=[ones(size(x)) x z];
a=X\y

[xi,zi]=meshgrid(...
  min(x(:)):range(x(:))/20:max(x(:)),...
  min(z(:)):range(z(:))/20:max(z(:)));

yi=a(1)+(a(2)*xi)+(a(3)*zi);



figure(1)
clf
plot3(x,y,z,'.');
set(gca,'projection','perspective');
xlabel('x'),ylabel('y'),zlabel('z');
hold on
mesh(xi,yi,zi,ones(size(xi)),'facealpha',0.5);
grid on

% now redo plane with transformed data
normal=[-a(2) 1 -a(3)]
theta=acos(normal(2)/norm(normal));
phi=acos(-normal(3)/norm(normal));  % why do we need the negative here???
psi=acos(normal(1)/norm(normal));
%keyboard
T=transform([0 0 0],[theta phi psi],[1 1 1]);
newpoints=T*[x'; y'; z'; ones(size(x))'];
newx=newpoints(1,:)';
newy=newpoints(2,:)';
newz=newpoints(3,:)';


newX=[ones(size(newx)) newx newy];
newa=newX\newz;
newnormal=[-newa(2) -newa(3) 1]

[newxi,newyi]=meshgrid(...
  min(newx(:)):range(newx(:))/20:max(newx(:)),...
  min(newy(:)):range(newy(:))/20:max(newy(:)));

newzi=newa(1)+(newa(2)*newxi)+(newa(3)*newyi);

figure(2)
clf
plot3(newx,newy,newz,'.');
set(gca,'projection','perspective');
xlabel('x'),ylabel('y'),zlabel('z');
hold on
mesh(newxi,newyi,newzi,ones(size(newxi)),'facealpha',0.5);
grid on


% now for the proper part...
points=[newx newy newz];
points=sortrows(points,3);  % sort by height
%zmin=input('Z minimum');
%zmax=input('Z maximum');

%points(find(points(:,3)<zmin))=[];  % get rid of outliers
%keyboard
%keyboard
zmean=mean(points(:,3))
zstd=std(points(:,3))

zmax=zmean+(1*zstd)
%points(find(points(:,3)>zmax),:)=[NaN];

plot3(points(:,1),points(:,2),points(:,3),'r.');


[newxi2,newyi2]=meshgrid(...
  min(points(:,1)):range(points(:,1))/80:max(points(:,1)),...
  min(points(:,2)):range(points(:,2))/80:max(points(:,2)));

newzi2=griddata(points(:,1),points(:,2),points(:,3),newxi2,newyi2);

newzi2(find(newzi2>zmax))=NaN;
%newzi2(find(newxi2>))=NaN;
%newzi2(find(newxi2<))=NaN;
newzi2(find(newyi2>max(newyi2(:))-10))=NaN;
newzi2(find(newyi2<min(newyi2(:))+10))=NaN;

figure(3)
clf
mesh(newxi2,newyi2,newzi2)
%surf(newxi2,newyi2,newzi2);
view(0,90)
shading flat


return


