function [x,y,z]=read_gws(filename)
% READ_GWS reads Mitutoyo CMM GWS files
% [x,y,z]=read_gws(filename) 
% Reads GWS files (from Mitutoyo CMM)
% Greg Johnson, June 2003

% count number of lines in file (useful only if file is LARGE!
if nargin~=1
  help read_gws
  return
end
if ~exist(filename,'file')
  disp('Cannot find file')
  x=[];y=[];z=[];
  return
end
fid=fopen(filename,'rt');

nLines=0;
while ~feof(fid)
  line=fgetl(fid);
  if strfind(line,'#03:')
    nLines=nLines+1;
  end
end
fclose(fid);
x=zeros(1,nLines);
y=zeros(1,nLines);
z=zeros(1,nLines);

fid=fopen(filename,'rt');
ndx=1;
while ~feof(fid)
  line=fgetl(fid);
  if ~isempty(strfind(line,'#03:')) ||  ~isempty(strfind(line,'#12:'))
    [a,b]=strtok(line,' ');
    [m,b]=strtok(b,' ');
    [n,b]=strtok(b,' ');
    [o,b]=strtok(b,' ');
    x(ndx)=str2num(m);
    y(ndx)=str2num(n);
    z(ndx)=str2num(o);
    ndx=ndx+1;
  end
end
      
fclose(fid);

x=x';
y=y';
z=z';