function [T,Ttranslate,Trotate,Tscale]=transform(translate,rotate,scale)
% translate is a 3 element row or column vector for x, y, & z translation
% rotate is a 3 element row or column vector for theta, phi, psi rotations 
% theta = rotation around x-axis (pitch)
% phi = rotation around y-axis (roll)
% psi = rotation around z-axis (yaw)
% applied in the following order (roll*pitch*yaw)  - NOT SURE I AGREE WITH
% THE NOTATION HERE
% scale is a 3 element vector for x,y, & z scale factors

if prod(scale)==0
  beep
  disp('Did you mean to scale everything to zero?')
end

theta=rotate(1);phi=rotate(2);psi=rotate(3);
Ttranslate=diag([1 1 1 1]);
  Ttranslate(1:3,4)=translate(:);


Tscale=diag([scale 1]);

Trotate=[...
    cos(psi)*cos(phi) + sin(psi)*sin(theta)*sin(phi),...
    sin(psi)*cos(phi) - cos(psi)*sin(theta)*sin(phi),...
    cos(theta)*sin(phi),...
    0;...
    -sin(psi)*cos(theta),...
    cos(psi)*cos(theta),...
    sin(theta),...
    0;...
    sin(psi)*sin(theta)*cos(phi)-cos(psi)*sin(phi),...
    -cos(psi)*sin(theta)*cos(phi)-sin(psi)*sin(phi),...
    cos(theta)*cos(phi),...
    0;...
    0,0,0,1]; 

T=Ttranslate*Tscale*Trotate;
    