% CMM_ALIGN.M
% Greg Johnson
% 2004/2005
% Need icp algorithm (C. Pirnog) - in the icp directory

clear all
fnameoutref=uigetfile('*.txt','Select REFERENCE outline file');%CG added square
if fnameoutref==0
  return
end

fnameref=uigetfile('*flat.txt','Select REFERENCE DATA file');%CG added flat
if fnameref==0
  return
end
fnameoutfloat=uigetfile('*out*.txt','Select FLOATING outline file');%CG added out
if fnameoutfloat==0
  return
end
fnamefloat=uigetfile('*flat.txt','Select FLOATING DATA file');%CG added flat
if fnamefloat==0
  return
end

fprintf('Reading data...\n');


r=read_three_columns(fnameoutref);
rdata=read_three_columns(fnameref);
f=read_three_columns(fnameoutfloat);
fdata=read_three_columns(fnamefloat);


%%Choose mirror axis added by CG 16-02-06
mirror_letter=input('What is the mirror axis, x or y:   ','s');
if mirror_letter=='x' || mirror_letter=='X'
    mirror=2;%Changed PF CG as backwards
end
if mirror_letter=='y'|| mirror_letter=='Y'
    mirror=1;%Changed PF CG as backwards
end
    
%% MIRROR DATA
% Data of the two surfaces usually needs reflectingmirroring, either across the x or
% y axis.  

%mirror=1;  % 1 = mirror in x, 2= mirror in y Removed 16-02-06 CG
if mirror==2
  fprintf('Mirroring data in XZ...\n');
  f(:,2)=-f(:,2);
  fdata(:,2)=-fdata(:,2);
elseif mirror==1
fprintf('Mirroring data in ZY...\n');
  f(:,1)=-f(:,1);
  fdata(:,1)=-fdata(:,1);
else
    fprintf('Not mirroring data - assuming done already...')
end
 
%% SQUARE DATA
% square off data if slightly squint wrt axis of measurement
% could use radon transform to determine whether (and how) to square off
% best - would be neater that squaredata which is a bit of a kludge.

if 0
  fprintf('Data IS being squared off - edit cmm_align to change\n')
  [r,rdata]=squaredata(r,rdata);
  [f,fdata]=squaredata(f,fdata);
else
  fprintf('Data is NOT being squared off - edit cmm_align to change\n');
end

%% CENTRE DATA
% Data is recentred here to a common origin, simply by moving the centre of
% gravity.  Full alignment is done later on, but this gets the gross errors
% out of the way

mean_fdata=mean(fdata);
f=f-repmat(mean_fdata,[length(f),1]);
fdata=fdata-repmat(mean_fdata,[length(fdata),1]);
mean_rdata=mean(rdata);
r=r-repmat(mean_rdata,[length(r),1]);
rdata=rdata-repmat(mean_rdata,[length(rdata),1]);

% we align only in x and y, so set z to zeros
r(:,3)=0;
f(:,3)=0;

%%%%%%%%%
% show starting position...

figure(1)
clf
rorig=r;
forig=f;
fprintf('Optional section removal: ')
if 0
  fprintf('Cropping...\n\n')
  r1=max(r(:,1))-min(r(:,1));
  r2=max(r(:,2))-min(r(:,2));
  if r1>r2
    % remove sections of outline around flashing of LFW
    r(find(r(:,1)>-10 & r(:,1)<10),:)=[];
    f(find(f(:,1)>-10 & f(:,1)<10),:)=[];
  else
    r(find(r(:,2)>-10 & r(:,2)<10),:)=[];
    f(find(f(:,2)>-10 & f(:,2)<10),:)=[];
  end
else
  fprintf('NOT cropping\n\n')
end


%% 3D plot
clf
plot3(r(:,1),r(:,2),r(:,3),'b.-')
hold on
plot3(f(:,1),f(:,2),f(:,3),'k.-');


plot3(rdata(:,1),rdata(:,2),rdata(:,3),'g.')
hold on
plot3(fdata(:,1),fdata(:,2),fdata(:,3),'r.');
title('Original data after mirroring')

%xlabel('x');ylabel('y');zlabel('z')
set(gca,'dataaspectratio',[1000 1000 1]);
view(0,90)
drawnow

%%


[fnew, tr, rot] = iterativeClosestPoint(r, f, 25,0.050);

fnew=fnew';
ax1=gca;
%%
figure(2)
clf
plot3(r(:,1),r(:,2),r(:,3),'g.');
hold on
plot3(fnew(:,1),fnew(:,2),fnew(:,3),'r.');

%%
% transform the data points in the same fashion as the outline
fdatanew= transpose(rot*fdata' + repmat(tr.', 1, size(fdata', 2)));
r=rorig;
f=transpose(rot*forig' + repmat(tr.',1,size(forig',2)));

plot3(rdata(:,1),rdata(:,2),rdata(:,3),'g.');
hold on

plot3(fdatanew(:,1),fdatanew(:,2),fdatanew(:,3),'r.');
title('Aligned data')
set(gca,'dataaspectratio',[1000 1000 1]);
view(0,90)
ax2=gca;
hlink=linkprop([ax1 ax2],{'CameraPosition','CameraUpVector'});

%% 2D figure
figure
clf
plot(r(:,1),r(:,2),'go');
hold on
plot(fnew(:,1),fnew(:,2),'ro');
plot(rdata(:,1),rdata(:,2),'g.');

plot(fdatanew(:,1),fdatanew(:,2),'r.')
axis equal
%%



% save the data
fprintf('Saving the data to _ALIGNED files\n');

dlmwrite([fnameref(1:end-4) '_aligned.txt'],[rdata],'delimiter',' ');
dlmwrite([fnameoutref(1:end-4) '_aligned.txt'],[r],'delimiter',' ');


dlmwrite([fnamefloat(1:end-4) '_aligned.txt'],[fdatanew],'delimiter',' ');
dlmwrite([fnameoutfloat(1:end-4) '_aligned.txt'],[fnew],'delimiter',' ');


