% CMM_EXAMINE.M A simple tool for looking at point clouds
% Greg Johnson
% July 2004
% Rhivendell, Ross-shire, Scotland
%
% Opens a point cloud and displays it

clear all

fnamedata=uigetfile('*.*','Select the data file');

if isequal(fnamedata,0)
  fprintf('Cancelled...\n');
  return
end

[x,y,z]=textread(fnamedata);


z=z-fit_plane(x,y,z);

viewaxis=1;

while 1
  clf
  plot3(x,y,z,'b.');
  if viewaxis==4
    viewvector=[.5 .5 1];
  else
    viewvector=zeros(1,3);
    viewvector(viewaxis)=1;
  end
  view(viewvector);
  
  [u1,u2,v1,v2]=cropbox(viewaxis);
  if isempty(u1)
    %check if user press a number key (1,2,3) to change view
    % or 'f' to re-flatten
    if strcmp(lower(u2),'f')
      disp('flatten')
      z=z-fit_plane(x,y,z);
      continue
    elseif strcmp(lower(u2),'q')
      fprintf('Quit...\n');
      return
      
    elseif any(str2double(u2)==[1 2 3 4])
      viewaxis=str2double(u2);
      continue;
    else
      break;
    end
  end
  hold on
  switch viewaxis
    case 1
      a=find(y>u1 & y<u2);
      b=find(z>v1 & z<v2);
    case 2
      a=find(x>u1 & x<u2);
      b=find(z>v1 & z<v2);
    case 3
      a=find(x>u1 & x<u2);
      b=find(y>v1 & y<v2);
    otherwise
      a=[];b=[];
  end
    
  %c=intersect(a,b);
  %x(c)=[];
  %y(c)=[];
  %z(c)=[];
end

close all
drawnow
