function [zfit,varargout]=fit_plane(x,y,z,varargin);
% FIT_PLANE.M 
% Usage:
% [zfit]=fit_plane(x,y,z);  
%   produces a correction value such that z-zfit will be 'flat' data
% [zfit,z2fit]=fit_plane(x,y,z,x2,y2)
%   uses the additional x2,y2 values to generate a second z2fit which can
%   be used in a similar fashion to correct z2 from a second dataset but
%   with the same levelling that was measured from z
%
%  Greg Johnson
%  July 2004

coeff=[x y ones(size(x))]\(-z);

zfit=-(coeff(1)*x + coeff(2)*y + coeff(3));


if nargin==5 & nargout==2
  zoutfit=-(coeff(1)*varargin{1} + coeff(2)*varargin{2} +coeff(3));
  varargout{1}=zoutfit;
elseif nargin==3 & nargout==1
  return
else
  fprintf('Incorrect usage\n\n')
  eval(['help ' mfilename])
  varargout=[];
  return
end
