disp('edit gen_picture for asweld=0 or =1')
asweld=0
id15=textread('s33id15.txt');
fem=textread('s33fem.txt','','headerlines',3);
%%
close all
figure(1)
clf
set(gcf,'renderer','zbuffer');
x1=id15(:,1)-mean(id15(:,1));
x2=fem(:,1)-mean(fem(:,1))+0.75;

s1=id15(:,2);
s2=fem(:,2);

p1=plot(x1,s1,'r.-');
hold on
p2=plot(x2,s2,'g.-');
l=legend({'Synchrotron data','CM data'});
xl=xlabel('Distance from weld line');
yl=ylabel('Hoop stress (MPa)');
if asweld==1
  titlestr='CM and Synchrotron data for as-welded Ti6-4 LFW'
else
  titlestr='CM and Synchrotron data for 1hr500 Ti6-4 LFW';
end

t=title(titlestr);
grid on

set(p1,'linewidth',3,'markersize',20,'linestyle','--')
set(p2,'linewidth',3,'markersize',20)
axis tight
set(gca,'fontsize',16)
set(t,'fontsize',30)
set(xl,'fontsize',20)
set(yl,'fontsize',20)
set(l,'fontsize',20)
axis([-inf inf -150 600])

set(gcf,'units','pixels')
set(gcf,'position',[40 40 560*2 420*2])

% renderer must be changed manually to get decent eps output
disp('use last line of gen_picture to generate an EPS version...')
exportfig(gcf,'test.eps','format','eps2','color','cmyk','preview','none','renderer','painters')